//
//  TitleLayer.m
//  Game01
//
//  Created by Kansuke Nishida on 11/09/18.
//  Copyright 2011年 tonosamart. All rights reserved.
//

#import "TitleLayer.h"
#import "GameScene.h"

@interface TitleLayer (private)
-(void)initLayer;
-(void)menuStart:(id)sender;
@end

@implementation TitleLayer

enum {
    SPRITE_NULL,
    SPRITE_PLAYER,
    SPRITE_TEXT,
    SPRITE_MENU
};

- (id)init{
    self = [super init];
    if (self) {
        // イベントの無効/有効
        self.isTouchEnabled = NO;
        self.isAccelerometerEnabled = NO;
        
        //レイヤーの初期化
        [self initLayer];
    }
    
    return self;
}

#pragma mark private

-(void)initLayer{
    CCSprite* sprite = [CCSprite spriteWithFile:@"free03_179.png"];
    sprite.position = ccp(0, 160);
    [self addChild:sprite z:SPRITE_PLAYER tag:SPRITE_PLAYER];

    NSMutableArray* moveRarray = [NSMutableArray array];
    [moveRarray addObject:[CCMoveTo actionWithDuration:3.0f position:ccp(480, 160)]];
    [moveRarray addObject:[CCRotateBy actionWithDuration:3.0f angle:360 * 4]];
    id moveRaction = [CCSpawn actionsWithArray:moveRarray];

    NSMutableArray* moveLarray = [NSMutableArray array];
    [moveLarray addObject:[CCMoveTo actionWithDuration:3.0f position:ccp(0, 160)]];
    [moveLarray addObject:[CCRotateBy actionWithDuration:3.0f angle:-(360 * 4)]];
    id moveLaction = [CCSpawn actionsWithArray:moveLarray];
    
    NSMutableArray* actions = [NSMutableArray array];
    [actions addObject:moveRaction];
    [actions addObject:moveLaction];
    
    id action;
    action = [CCSequence actionsWithArray:actions];
    action = [CCRepeatForever actionWithAction:action];
	[sprite runAction:action];

    //---
    
    CCLabelTTF* label = [CCLabelTTF labelWithString:@"PANDA GAME" fontName:@"retrogame" fontSize:48];
    label.color = ccc3(255, 0, 0);
    label.position = ccp(240, 240);
    [self addChild:label z:SPRITE_TEXT tag:SPRITE_TEXT]; 
    
    [CCMenuItemFont setFontName:@"Marker Felt"];
    [CCMenuItemFont setFontSize:32];
    CCMenuItem *startButton = [CCMenuItemFont itemFromString:@"START" target:self selector:@selector(menuStart:)];
    startButton.position = ccp(240, 80);
    
    CCMenu *menu = [CCMenu menuWithItems:startButton, nil];
    menu.position = ccp(0,0);
    [self addChild:menu z:SPRITE_MENU tag:SPRITE_MENU];
}

-(void)menuStart:(id)sender{
    [[CCDirector sharedDirector] replaceScene:[CCTransitionFade transitionWithDuration:2.0f scene:[GameScene node] withColor:ccc3(255, 255, 255)]];
}
@end

